function [dxtriF,dxnode,dxxnode] = dx_cart_mesh(InMeshFile,plott)
%FINDALT calc. an "altitude" for each tria-cell in the mesh.
[tri,longitude,latitude,h]=readWW3mesh(InMeshFile,0);
    geom.mshID = 'ELLIPSOID-MESH' ;
    geom.radii = 6371 * ones(3,1) ;
    S(:,1)=longitude*pi/180;
    S(:,2)=latitude*pi/180;
[E3] = S2toR3(geom.radii,S);
x=E3(:,1);
y=E3(:,2);
z=E3(:,3);
dxtri(1,:)=sqrt((x(tri(:,1))-x(tri(:,2))).^2+...
(y(tri(:,1))-y(tri(:,2))).^2+...
(z(tri(:,1))-z(tri(:,2))).^2);

dxtri(2,:)=sqrt((x(tri(:,1))-x(tri(:,3))).^2+...
(y(tri(:,1))-y(tri(:,3))).^2+...
(z(tri(:,1))-z(tri(:,3))).^2);

dxtri(3,:)=sqrt((x(tri(:,3))-x(tri(:,2))).^2+...
(y(tri(:,3))-y(tri(:,2))).^2+...
(z(tri(:,3))-z(tri(:,2))).^2);

dxtriF=(dxtri(1,:)+dxtri(2,:)+dxtri(3,:))/ +3.0 ;

%for i=1:length(tri(:,1))
%    XA(i,1)=(longitude(tri(i,1))+longitude(tri(i,2))+longitude(tri(i,3)))/3;
%    YA(i,1)=(latitude(tri(i,1))+latitude(tri(i,2))+latitude(tri(i,3)))/3;
%end

    XA(:,1)=(longitude(tri(:,1))+longitude(tri(:,2))+longitude(tri(:,3)))/3;
    YA(:,1)=(latitude(tri(:,1))+latitude(tri(:,2))+latitude(tri(:,3)))/3;
xxA(:,1)=(x(tri(:,1))+x(tri(:,2))+x(tri(:,3)))/3;
yyA(:,1)=(y(tri(:,1))+y(tri(:,2))+y(tri(:,3)))/3;
zzA(:,1)=(z(tri(:,1))+z(tri(:,2))+z(tri(:,3)))/3;

[n,d]=knnsearch([XA,YA],[longitude,latitude],'k',4);
AAA=min(dxtri);
BBB(:,1)=AAA(1,:);
dxnode=BBB(n(:,1));



[nn,dd]=knnsearch([xxA,yyA,zzA],[xxA,yyA,zzA],'k',2);
BBBB=dd(:,2);
dxxnode=BBBB(n(:,1));%should be n not nn


% this is another alternative to calculate dxnode
%[nnn,ddd]=knnsearch([x,y,z],[x,y,z],'k',2);
%dxnode=ddd(:,2);


%%

if plott==1

 [X,Y]=meshgrid(min(longitude):(max(longitude)-min(longitude))/360/4:max(longitude),min(latitude):(max(latitude)-min(latitude))/180/4:max(latitude));   
DXNODE=reshape(griddata(longitude,latitude,dxnode,X(:),Y(:)),size(X));
DXXNODE=reshape(griddata(longitude,latitude,dxxnode,X(:),Y(:)),size(X));

width=1000;  % Width of figure for movie [pixels]
height=1000;  % Height of figure of movie [pixels]
left=10;     % Left margin between figure and screen edge [pixels]
bottom=10;  % Bottom margin between figure and screen edge [pixels]

load coast
if max(longitude)>180 
long(long<=0)=long(long<=0)+360;
long(long<=3)=nan;
end
figure('Color','w');
set(gcf,'Position', [left bottom width height])
subplot(1,1,1)
axis equal
dxnode1=dxnode;
dxnode1(longitude<=min(longitude)+2)=nan;
%[CS,h]=tricontf(x,y,tri,h,[0:50:500]);
trisurf(tri,longitude,latitude,dxnode1);
shading interp
view(2)
hold on
plot3(long,lat,1000*ones(size(long)),'-k','linewidth',2)
hold on;

hold off;
colorbar

grid off
axis on
axis equal
%xlim([min(x) max(x)])
%ylim([min(y) max(y)])
xlim([min(longitude) max(longitude)])
%ylim([-90 90])
ylim([min(latitude) max(latitude)])

title('\Deltax [ km ]','Fontsize',18)
print(gcf,'-dpng',['DeltaX',InMeshFile,'.png'],'-r500');



load geoid

 
if max(X(:))-min(X(:))<350
latlim = [min(Y(:))-.1 max(Y(:))+.1];
lonlim = [min(X(:))-.1 max(X(:))+.1];
else
latlim = [min(Y(:)) max(Y(:))];
lonlim = [min(X(:)) max(X(:))];
if min(X(:))<0
lonlim=[0 360];
end
end

figure('Color','w');
set(gcf,'Position', [left bottom width height])


axesm eckert4; 
framem; gridm;
axis off

%geoidrefvec=[1,360,0];
axesm('robinson','MapLatLimit',latlim,'MapLonLimit',lonlim,...
    'Frame','on','Grid','on','MeridianLabel','on','ParallelLabel','on')

geoshow(Y,X,DXNODE, 'DisplayType', 'texturemap');

hcb = colorbar('southoutside');
set(get(hcb,'Xlabel'),'String','\Deltax [ km ]','Fontsize',20)
caxis([min(DXNODE(:)) max(DXNODE(:))]);
geoshow('landareas.shp', 'FaceColor', 'white');


print(gcf,'-dpng',['DeltaX_Projected',InMeshFile,'.png'],'-r500');



%%
figure('Color','w');
set(gcf,'Position', [left bottom width height])
subplot(1,2,2)

text(0,14,['nodes  = ',num2str(length(longitude))],'FontSize',20)
text(0,10,['elements = ',num2str(length(tri(:,1)))],'FontSize',20)
text(0,6,['\Deltax_{min} = ',num2str(min(dxnode),'%.2f'),' km'],'FontSize',20)
text(0,2,['\Deltax_{max} = ',num2str(max(dxnode),'%.2f'),' km'],'FontSize',20)

axis off
box off
xlim([-0 10])
ylim([-0 16])

subplot(1,2,1)
histogram(dxnode,100)
%xlim([0 600])
xlabel('\Deltax [ km ]','FontSize',20)
print(gcf,'-dpng',['histogram_',InMeshFile,'.png'],'-r500');



figure('Color','w');
set(gcf,'Position', [left bottom width height])
subplot(1,1,1)
axis equal
dxnode1=dxxnode;
dxnode1(longitude<=min(longitude)+2)=nan;
%[CS,h]=tricontf(x,y,tri,h,[0:50:500]);
trisurf(tri,longitude,latitude,dxnode1);
shading interp
view(2)
hold on
plot3(long,lat,1000*ones(size(long)),'-k','linewidth',2)
hold on;

hold off;
colorbar

grid off
axis on
axis equal
%xlim([min(x) max(x)])
%ylim([min(y) max(y)])
xlim([min(longitude) max(longitude)])
%ylim([-90 90])
ylim([min(latitude) max(latitude)])
caxis([0 1.1*prctile(dxxnode,95)])
title('\Deltax [ km ]','Fontsize',18)
print(gcf,'-dpng',['DeltaX_element_',InMeshFile,'.png'],'-r500');



load geoid

 

figure('Color','w');
set(gcf,'Position', [left bottom width height])


axesm eckert4; 
framem; gridm;
axis off

%geoidrefvec=[1,360,0];
axesm('robinson','MapLatLimit',latlim,'MapLonLimit',lonlim,...
    'Frame','on','Grid','on','MeridianLabel','on','ParallelLabel','on')

geoshow(Y,X,DXXNODE, 'DisplayType', 'texturemap');

hcb = colorbar('southoutside');
set(get(hcb,'Xlabel'),'String','\Deltax [ km ]','Fontsize',20)
caxis([min(DXXNODE(:)) 1.1*prctile(DXXNODE(:),95)]);

geoshow('landareas.shp', 'FaceColor', 'white');


print(gcf,'-dpng',['DeltaX_element_Projected',InMeshFile,'.png'],'-r500');




%%
figure('Color','w');
set(gcf,'Position', [left bottom width height])
subplot(1,2,2)

text(0,14,['nodes  = ',num2str(length(longitude))],'FontSize',20)
text(0,10,['elements = ',num2str(length(tri(:,1)))],'FontSize',20)
text(0,6,['\Deltax_{min} = ',num2str(min(dxxnode),'%.2f'),' km'],'FontSize',20)
text(0,2,['\Deltax_{max} = ',num2str(1.01*prctile(dxxnode,99),'%.2f'),' km'],'FontSize',20)

axis off
box off
xlim([-0 10])
ylim([-0 16])

subplot(1,2,1)
histogram(dxxnode,100)
xlim([0 1.1*prctile(dxxnode,95)])
xlabel('\Deltax [ km ]','FontSize',20)
print(gcf,'-dpng',['histogram_element_',InMeshFile,'.png'],'-r500');


end

end
